package yrpg.slm.pc.plugin.other;

import kd.bos.algo.DataSet;
import kd.bos.algo.GroupbyDataSet;
import kd.bos.algo.JoinDataSet;
import kd.bos.algo.JoinType;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.property.BasedataProp;
import kd.bos.entity.property.EntryProp;
import kd.bos.exception.KDBizException;
import kd.bos.formula.platform.engine.FormulaEngine;
import kd.bos.formula.platform.engine.RunFormulaException;
import kd.bos.metadata.dao.MetaCategory;
import kd.bos.metadata.dao.MetadataDao;
import kd.bos.metadata.form.ControlAp;
import kd.bos.metadata.form.FormMetadata;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.permission.api.DataRuleResult;
import kd.bos.permission.api.DataRuleSingleResult;
import kd.bos.permission.cache.util.PermCommonUtil;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.MetadataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.botp.BFTrackerServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import yrpg.slm.pc.common.CaluteCircleConstant;
import yrpg.slm.pc.common.CaluteConstant;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAdjusters;
import java.util.Map;
import java.util.List;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;

/**
 * @ClassName SyncBusinessListHelper
 * @Description TODO 订阅事件自动获取业务清单数据并生成工资计算数据源帮助类。
 * @DATE 2024/5/1 15:20
 * @CREATED BY 白一帆
 **/
public class SyncBusinessListHelper {

    static final String EXP_TO_WAGES_RULE_ID = "1940548796270266368"; //业务清单下推工资计算单转换规则id;

    /**
     * 根据业务清单事件触发生成工资计算单并生成奖项明细等信息
     * @param filter 查询业务清单的过滤条件。
     * @return
     */
    public static void generateCalumate(QFilter filter){
        //查询业务清单并自动下推
        ConvertOperationResult convertOperationResult = autoPush(filter);
        if(convertOperationResult.isSuccess()){
            //获取下推成功的计算单id
            Set<Object> targetBillIds = convertOperationResult.getTargetBillIds();
            DynamicObjectCollection yrpgExpBusinesslistquery = QueryServiceHelper.query("yrpg_wages_calate",
                    "id,yrpg_bbussiness.number,yrpg_post.number", new QFilter[]{new
                    QFilter("id", QFilter.in, targetBillIds)});
            Map<String, List<DynamicObject>> yrpgBussinessid = yrpgExpBusinesslistquery.stream().collect(Collectors.groupingBy(x -> {
                return x.getString("yrpg_bbussiness.number")
//                        +",,,"+x.getString("yrpg_post.number")
                        ;
            }, Collectors.toList()));
                         DynamicObjectCollection yrpgPcAwardtype = QueryServiceHelper.query("yrpg_pc_awardtype",
                    "id,yrpg_businessline.number,yrpg_compute,yrpg_job.fbasedataid.number",
                    new QFilter[]{new QFilter("status", QFilter.equals, "C")});

//            typemap.entrySet().stream().forEach(x->{
//                String key = x.getKey();
//                String value = x.getValue();
//                List<Long> id = yrpgBussinessid.containsKey(value)?yrpgBussinessid.get(value).stream().map(x1 -> {
//                    return x1.getLong("id");
//                }).collect(Collectors.toList()):new ArrayList<>();
//                OperationResult yrpgWagesCalate = OperationServiceHelper.executeOperate(key, "yrpg_wages_calate",
//                        id.toArray(new Long[]{}), OperateOption.create());
//            });
            //根据期间等过滤条件获取计算单
            //将计算单中的销售队伍进行分组。
            Map<String, List<DynamicObject>> yrpgBbussinessgroup = yrpgExpBusinesslistquery.stream().collect(Collectors.groupingBy(x -> {
                return x.getString("yrpg_bbussiness.number");
            }, Collectors.toList()));

            //根据销售队伍获取所有相关的计算奖项。并将销售队伍和相关奖项一一对应。
            Set<String> bussiness = yrpgBbussinessgroup.keySet();
            DynamicObjectCollection yrpgPcAwardType = QueryServiceHelper.query("yrpg_pc_awardtype",
                    "yrpg_compute,yrpg_businessline.number,yrpg_job.fbasedataid.number", new QFilter[]{new QFilter("yrpg_businessline.number",
                            QFilter.in, bussiness)});
            Map<String, List<DynamicObject>> yrpgPcAwardTypeGroup = yrpgPcAwardType.stream().collect(Collectors.groupingBy(x -> {
                return x.getString("yrpg_businessline.number")
//                        +",,,"+x.getString("yrpg_job.fbasedataid.number")
                        ;
            }, Collectors.toList()));
            //获取所有的奖项信息
            List<String> yrpgCompute = yrpgPcAwardTypeGroup.values().stream().flatMap(x -> {
                return x.stream();
            }).map(x -> {
                return x.getString("yrpg_compute")
//                                        +",,,"+x.getString("yrpg_post.number")
;
            }).distinct().collect(Collectors.toList());
            //根据奖项信息获取所有奖项单据
            //todo:根据奖项信息作为目标单获取所有取数规则
            DynamicObjectCollection yrpgPcDataRules = QueryServiceHelper.query("yrpg_pc_data_rules", "yrpg_sourcebill.number," +
                            "yrpg_targetbill.number,id,yrpg_filtertext,yrpg_pc_distributecycle.number,yrpg_priority,yrpg_backwrite_ref" +
                            ".yrpg_targettag,yrpg_backwrite_ref.yrpg_sourcetag,yrpg_backwrite_ref.yrpg_backdirection," +
                            "yrpg_source_tar_ref.yrpg_sourcebilltag,yrpg_source_tar_ref.yrpg_targetbilltag,yrpg_source_tar_ref.yrpg_comparetag",
                    new QFilter[]{new QFilter("yrpg_targetbill.number", QFilter.in, yrpgCompute),
                    new QFilter("yrpg_businessdomain",QFilter.equals, CaluteConstant
                            .BUSSINESS_DOMAIN_PERFORM.getCode())
//                            , new QFilter("status",QFilter.equals,"C")
            });
            Map<String, List<DynamicObject>> srcBillNumber = yrpgPcDataRules.stream().collect(Collectors.groupingBy(x -> {
                return x.getString("yrpg_sourcebill.number");
            }, Collectors.toList()));
            Map<String, List<DynamicObject>> tarBillNumber = yrpgPcDataRules.stream().collect(Collectors.groupingBy(x -> {
                return x.getString("yrpg_targetbill.number");
            }, Collectors.toList()));
            //todo: 将取数规则根据源单。目标单。序号进行分组。

            Map<String, List<DynamicObject>> yrpgPriority = yrpgPcDataRules.stream().collect(Collectors.groupingBy(x -> {
                return x.getString("yrpg_sourcebill.number") +",,,"+x.getLong("id")+ ",,," + x.getString("yrpg_targetbill.number")+ ",,,"
                        + x.getString("yrpg_priority")
                        ;
            },Collectors.toList()));
            Map<String,DataSet> srcMapResult= new HashMap<>();//源单单所有数据集合
            Map<String,DataSet> targetMapResult= new HashMap<>();//目标单所有数据集合
            Map<String,String> targetTagName= new HashMap<>();//目标单所有字段标识映射
             Map<String,String> srcTagNames = new HashMap<>();//源单所有字段标识映射
            //todo:   将其他的源单的所有字段查询一次性查询出来。
            srcBillNumber.forEach((x,y)->{
                List<String> yrpgSourceTag = y.stream().filter(x1->{
                    return !StringUtils.isEmpty(x1.getString("yrpg_backwrite_ref.yrpg_sourcetag") );
                }).map(x1 -> {
                    return x1.getString("yrpg_backwrite_ref.yrpg_sourcetag") ;
                }).distinct().collect(Collectors.toList());
                List<String> yrpgSourceBillTag = y.stream().filter(x1->{
                    return !StringUtils.isEmpty(x1.getString("yrpg_source_tar_ref.yrpg_sourcebilltag") );
                }).map(x1 -> {
                    return x1.getString("yrpg_source_tar_ref.yrpg_sourcebilltag");
                }).distinct().collect(Collectors.toList());
                yrpgSourceBillTag.add("createtime");

                yrpgSourceTag.addAll(yrpgSourceBillTag);
                //获取所有源单标识去重后的集合，方便查询源单数据携带字段
                List<String> srcBillTagNames1 = yrpgSourceTag.stream().distinct()
                        .map(x1->{
                            return x1 + " as src_"+ x1 ;
                        })
                         .collect(Collectors.toList());
                String srcTagName1 = String.join(",",srcBillTagNames1.toArray(new String[]{}));
                String srcTagNameSelect = String.join(",",yrpgSourceTag.stream().distinct().collect(Collectors.toList())
                        .toArray(new String[]{}));
                Map<String, List<DynamicObject>> collect = y.stream().filter(xq->{
                    return xq.getString("yrpg_sourcebill.number").equals(x);
                                            }).collect(Collectors.groupingBy(xa -> {
                    return xa.getString("yrpg_sourcebill.number") +",,,"+xa.getLong("id")+ ",,," + xa.getString("yrpg_targetbill.number")+ ",,,"
                            + xa.getString("yrpg_priority");
                }, Collectors.toList()));
                DataSet srcResult = QueryServiceHelper.queryDataSet(x,x, srcTagNameSelect, new QFilter[]{},null);

                collect.keySet().forEach(xf->{
                    List<DynamicObject> list = collect.containsKey(xf)?collect.get(xf):new ArrayList<>();
                    //将源单字段与目标端字段映射匹配
                    //获取源单所有需要分组的依据
                    List<String> groupValues = list.stream().filter(xa -> {
                        return xa.getString("yrpg_source_tar_ref.yrpg_comparetag") != null&&
                                StringUtils.isNotEmpty(xa.getString("yrpg_source_tar_ref.yrpg_comparetag"))&&!xa.getString("yrpg_source_tar_ref.yrpg_comparetag").equals("null") && StringUtils.isNotEmpty(
                                xa.getString("yrpg_source_tar_ref.yrpg_comparetag")) && "=".equals(xa.getString("yrpg_source_tar_ref.yrpg_comparetag"));
                    }).map(xa -> {
                        return xa.getString("yrpg_source_tar_ref.yrpg_sourcebilltag");
                    }).collect(Collectors.toList());
                    List<String> yrpgCompareSum = list.stream().filter(xa -> {
                        return xa.getString("yrpg_backwrite_ref.yrpg_sourcetag") != null && !xa.getString("yrpg_backwrite_ref.yrpg_sourcetag").equals("null") && StringUtils.isNotEmpty(
                                xa.getString("yrpg_backwrite_ref.yrpg_sourcetag")) && (xa.getString("yrpg_backwrite_ref.yrpg_sourcetag").contains("qty") ||
                                xa.getString("yrpg_backwrite_ref.yrpg_sourcetag").contains("amount"));
                    }).map(xa -> {
                        return  xa.getString("yrpg_backwrite_ref.yrpg_sourcetag");
                    }).distinct().collect(Collectors.toList());
                    String dateFilter = "";
                    if (list != null && list.size() > 0 && list.get(0).getString("yrpg_pc_distributecycle.number") != null) {
                        //计算不同周期类型的数据
                        if (CaluteCircleConstant.CYCLE_QUARTER.getName().equals(list.get(0).getString("yrpg_pc_distributecycle.number"))) {
                            dateFilter =
                                    " createtime > TO_DATE('" + getQuaterStart() + "','yyyy-MM-dd') " +
                                            "and createtime < TO_DATE('" + getQuaterEnd() + "','yyyy-MM-dd')";

                        }
                        if (CaluteCircleConstant.CYCLE_MONTH.getName().equals(list.get(0).getString("yrpg_pc_distributecycle.number"))) {
                            dateFilter = " createtime > TO_DATE('" + getMonthStart() + "','yyyy-MM-dd') and " +
                                    "createtime < TO_DATE('" + getMonthEnd() + "','yyyy-MM-dd')";

                        }
                        if (CaluteCircleConstant.CYCLE_YEAR.getName().equals(list.get(0).getString("yrpg_pc_distributecycle.number"))) {
                            dateFilter = " createtime > TO_DATE('" + getYearStart() + "','yyyy-MM-dd') and" +
                                    " createtime < TO_DATE('" + getYearEnd() + "','yyyy-MM-dd')";

                        }
                        if (CaluteCircleConstant.CYCLE_HALF_YEAR.getName().equals(list.get(0).getString("yrpg_pc_distributecycle.number"))) {
                            dateFilter = " createtime > TO_DATE('" + getHalfYearStart() + "','yyyy-MM-dd')" +
                                    " and createtime < TO_DATE('" + getHalfYearEnd() + "','yyyy-MM-dd')";

                        }

                    }
                    List<String> collect1 = list.stream().map(xd -> {
                        return "src_"+xd.getString("yrpg_backwrite_ref.yrpg_sourcetag")+" as " +
                                "tar_"+xd.getString("yrpg_backwrite_ref.yrpg_targettag");
                    }).collect(Collectors.toList());
                    srcTagNames.put(xf,String.join(",",collect1.toArray(new String[]{})));
                    //获取源单过滤进行过滤
                    List<String> collect2 = list.stream().filter(xx->{
                        return !StringUtils.isEmpty(xx.getString("yrpg_filtertext"));
                    }).map(xx -> {
                        return xx.getString("yrpg_filtertext");
                    }).collect(Collectors.toList());
                    for(DynamicObject detail : list){
                        DataSet ds = srcResult.copy();
 //                        if(srcMapResult.containsKey(xf)){
//                           ds = srcMapResult.get(xf);
//                        }
                        String filtervalue = detail.getString("yrpg_filtertext").trim();
                        if(!filtervalue.isEmpty()&&!dateFilter.trim().isEmpty()){
                            filtervalue += " and ";
                        }
                        filtervalue += filtervalue+dateFilter;
                        if(!StringUtils.isEmpty(filtervalue.trim())) {
                            ds = ds.filter(filtervalue.trim() );
                        }
                        GroupbyDataSet groupbyDataSet = null;
                        if(!groupValues.isEmpty()){
                            groupbyDataSet = ds.copy().groupBy(groupValues.stream().distinct().collect(Collectors.toList()).toArray(new String[]{}));

                        }else{
                            groupbyDataSet = ds.copy().groupBy(ds.getRowMeta().getFieldNames());

                        }
                        for(String sumname : yrpgCompareSum ){
                            groupbyDataSet.sum(sumname);
                        }
                        DataSet groupResult = groupbyDataSet.finish();
                        List<String> select = new ArrayList<>();
                       List<String> dsFields = new ArrayList<>(Arrays.asList(ds.getRowMeta().getFieldNames()));
                       List<String> groupFields =  new ArrayList<>(Arrays.asList(
                                groupResult.getRowMeta().getFieldNames()));
                        Iterator<String> iterator = dsFields.iterator();
                        while(iterator.hasNext()){
                            String name = iterator.next();
                            if(!groupFields.contains(name)){
                                select.add(name);
                            }
                        }
                        JoinDataSet select2 = groupResult.join(ds.copy(), JoinType.INNER
                        );
                        if(groupValues.isEmpty()){
                            groupValues = new ArrayList<>(Arrays.asList(groupResult.getRowMeta().getFieldNames()));
                        }
                        for(String group :groupValues){
                            select2.on(group,group);
                        }
                        DataSet select1 = select2.select(groupFields.toArray(new String[]{}), select.toArray(new String[]{})).finish();
                        String[] fieldNames = select1.getRowMeta().getFieldNames();
                        List<String> collect3 = Arrays.stream(fieldNames).distinct().map(xq -> {
                            return xq + " as src_" + xq;
                        }).collect(Collectors.toList());
                        srcMapResult.put(xf,select1.select(collect3.toArray(new String[]{})));
                    }
                });
            });
            //todo:据工资计算明细自动下推奖项信息
            Map<String, List<Object>> computeDetails = makeComputDetail(yrpgBussinessid, yrpgPcAwardTypeGroup);
            Map<String, String> objectObjectHashMap = new HashMap<>();
            Map<String,Map<String,String>> objectObjectHashList = new HashMap<>();

            tarBillNumber.forEach((x,y)->{
                List<String> yrpgSourceTag = y.stream().map(x1 -> {
                    return x1.getString("yrpg_source_tar_ref.yrpg_targetbilltag") + " as tar_"+x1.getString("yrpg_source_tar_ref.yrpg_targetbilltag");
                }).distinct().collect(Collectors.toList());
                objectObjectHashMap.put(x,String.join(",",y.stream().map(x1->{
                    return x1.getString("yrpg_backwrite_ref.yrpg_targettag");
                }).collect(Collectors.toList()).toArray(new String[]{})));
                List<String> collect = y.stream().map(xy -> {
                    return "tar_" + xy.getString("yrpg_backwrite_ref.yrpg_sourcetag") + " as " + xy.getString("yrpg_backwrite_ref.yrpg_targettag");
                }).distinct().collect(Collectors.toList());
                Map<String, String> collect1 = collect.stream().collect(Collectors.toMap(xy -> {
                    return xy.split(" as ")[1];
                }, yx -> {
                    return yx.split(" as ")[0];
                }));

                objectObjectHashList.put(x,collect1);
                List<String> tarBillTagNames1 = yrpgSourceTag.stream().distinct().collect(Collectors.toList());
                 String srcTagName1 = String.join(",",tarBillTagNames1.toArray(new String[]{}))+",yrpg_srcid as tar_yrpg_srcid,yrpg_prize_entry.id as tar_yrpg_prize_entry.id,id as tar_id";
                targetTagName.put(x,srcTagName1);
                DataSet srcResult = QueryServiceHelper.queryDataSet(x,x, srcTagName1, new QFilter[]{new QFilter("yrpg_srcid",QFilter.in,computeDetails.containsKey(x)?computeDetails.get(x):new ArrayList<>())},null);
                targetMapResult.put(x,srcResult.copy());
            });
            //todo:根据取数规则数据取出对应源单的过滤信息
            Map<String,String> qFilterMap = new HashMap<>();
            for (Map.Entry entry : yrpgPriority.entrySet()) {
                String key = (String)entry.getKey();
                List<DynamicObject> value = (List<DynamicObject>)entry.getValue();
                qFilterMap.put(key,String.join(",",value.stream().map(x->{
                    return x.getString("yrpg_filtertext");
                } ).collect(Collectors.toList()).toArray(new String[]{})));
            }
            List<String> computed = new ArrayList<>();
            Map<String,List<String>> groupbyNames = new HashMap<>();
            Map<String,List<String>> sumNames = new HashMap<>();
            //todo:根据计算单中的销售队伍进行遍历，找出计算单应该生成哪些类型的奖项信息
            yrpgBbussinessgroup.keySet().forEach(x->{
                List<DynamicObject> list =yrpgPcAwardTypeGroup.containsKey(x)? yrpgPcAwardTypeGroup.get(x):new ArrayList<>();
               //todo:根据当前销售队伍找出相关的奖项明细
                 for(DynamicObject com :list){
//                     if(com.getString("yrpg_compute").equals("yrpg_sale_reacb")) {
                         DataSet tarDs = targetMapResult.containsKey(com.getString("yrpg_compute")) ? targetMapResult.get(com.getString("yrpg_compute")).copy() : null;
                         String yrpgCompute1 = com.getString("yrpg_compute");
                         AtomicInteger finalI = new AtomicInteger(1);
                         String ends = yrpgPriority.keySet().stream().filter(x1 -> {
                             return x1.endsWith(",,," + yrpgCompute1 + ",,," + finalI.get());
                         }).findFirst().orElse("");
                         //todo:按照奖项优先级遍历取数规则
                         while (yrpgPriority.containsKey(ends) && !computed.contains(ends)) {

                             computed.add(ends);
                             String srcEntity = qFilterMap.get(ends);
                             DataSet srcRows = srcMapResult.containsKey(ends) ? srcMapResult.get(ends).copy() : null;
                             if (srcRows != null) {
//                            DataSet srcDs = srcRows.filter(srcEntity);
                                 DataSet srcDs = srcRows.copy();
                                 //获取取数规则
                                 List<DynamicObject> pcData = yrpgPriority.get(ends);
//                        for(DynamicObject pcData : pcDatas) {

                                 List<DynamicObject> yrpgComparetag1Equals = pcData.stream().filter(xa -> {
                                     return "=".equals(xa.getString("yrpg_source_tar_ref.yrpg_comparetag"));
                                 }).collect(Collectors.toList());

                                 //将取数规则中的yrpg_backwrite_ref(反写字段分录信息)中的源单/目标单映射字段进行匹配。
                                 String finalEnds = ends;


//                                 List<String> yrpgCompareSrcGroupBy = pcData.stream().filter(xa -> {
//                                     return
////                                             (xa.getString("yrpg_sourcebill.number") +",,,"
////                                             +xa.getLong("id")+ ",,," + xa.getString("yrpg_targetbill.number")+ ",,,"
////                                             + xa.getString("yrpg_priority")).equals(finalEnds)&&
//                                             !xa.getString("yrpg_source_tar_ref.yrpg_comparetag").equals("null") && StringUtils.isNotEmpty(
//                                             xa.getString("yrpg_source_tar_ref.yrpg_comparetag")) && "=".equals(xa.getString("yrpg_source_tar_ref.yrpg_comparetag"));
//                                 }).map(xa -> {
//                                     return "tar_" + xa.getString("yrpg_source_tar_ref.yrpg_targetbilltag");
//                                 }).collect(Collectors.toList());
//                                 if (groupbyNames.containsKey(yrpgCompute1)) {
//                                     yrpgCompareSrcGroupBy.addAll(groupbyNames.get(yrpgCompute1));
//                                 }
//                                 //获取当前奖项明细的分组字段
//                                 groupbyNames.put(ends, yrpgCompareSrcGroupBy.stream().distinct().collect(Collectors.toList()));


                                  Map<String, String> mapsrctoTar = new HashMap<>();
                                 for (DynamicObject entrytag : yrpgComparetag1Equals) {
                                     mapsrctoTar.put("tar_" + entrytag.getString("yrpg_source_tar_ref.yrpg_targetbilltag"), "src_" + entrytag.getString("yrpg_source_tar_ref.yrpg_sourcebilltag"));
                                 }

                                 if (tarDs != null && srcDs != null) {
                                     JoinDataSet join = tarDs.copy().join(srcDs.copy(), JoinType.LEFT);
                                     for (Map.Entry<String, String> stringStringEntry : mapsrctoTar.entrySet()) {
                                         join.on(stringStringEntry.getKey(), stringStringEntry.getValue());
                                     }

                                     //查询目标单+源单的字段，如果源单字段不存在，则查询
                                     Boolean srcCreatetime = Arrays.stream(tarDs.getRowMeta().getFieldNames()).anyMatch(x11 -> {
                                         return x11.equals("src_createtime");
                                     });
                                     List<String> strings1 = new ArrayList<>(Arrays.asList(tarDs.getRowMeta().getFieldNames()));
                                     if (srcCreatetime) {
                                         strings1.remove("src_createtime");
                                     }
                                     List<String> strings = strings1.stream().filter(xx -> {
                                         return !xx.contains("null");
                                     }).collect(Collectors.toList());
                                     String[] fieldNames = srcDs.getRowMeta().getFieldNames();
                                     for(String srcname : fieldNames){
                                         if(strings.contains("tar_"+srcname.replace("src_",""))){
                                             strings.remove("tar_"+srcname.replace("src_",""));
                                         }
                                     }
                                     List<String> src = Arrays.stream(fieldNames).map(xqx -> {
                                          return xqx + " as tar_" + xqx.replace("src_", "");
                                     }).collect(Collectors.toList());
//                                     src.addAll(strings);
                                     String.join(",",src.toArray(new String[]{}));
                                    DataSet  tarDs1 = join.select(
//                                             String.join(",",src.toArray(new String[]{}))
                                             strings.toArray(new String[]{})
                                             , src.toArray(new String[]{})
                                             ).finish();
                                    tarDs = tarDs1.copy();
//                                     if (StringUtils.isNotEmpty(andStrs)) {
//                                         tarDs = tarDs.where(andStrs);
//                                     }
                                 }
                             }
                             finalI.incrementAndGet();
                             ends = yrpgPriority.keySet().stream().filter(x1 -> {
                                 return x1.endsWith(",,," + yrpgCompute1 + ",,," + finalI.get());
                             }).findFirst().orElse("");
//                        }
                         }
                         if (tarDs != null) {
//                             DataSet finish = ds.select(groups.toArray(new String[]{})).copy();
                             //设置计算奖项明细中的计算字段并进行计算
                             makeCompute(tarDs, yrpgCompute1, targetBillIds, objectObjectHashMap.get(com.getString("yrpg_compute")),
                                     targetTagName,objectObjectHashList.get(com.getString("yrpg_compute")));
//                         }
                     }
                 }
            });

           /**todo:1. 获取源单数据
        Map<String, DataSet> srcData = getSrcData(yrpgPcDataRules,yrpgPriority);
         DynamicObject[] yrpgSrcids = BusinessDataServiceHelper.load(compute, "", new QFilter[]{new QFilter("yrpg_srcid", QFilter.in, computeIds)});




          todo:1. 获取目标单数据
         Map<String, DataSet> tarData = getTargetData(yrpgPcDataRules,businessListDataSet.copy(),yrpgCompute,srcMapResult,);

            1. 将销售队伍下所有的取数规则每个源单信息所需要取的源单字段+源单字段标识进行合并。

            5. map:key：销售队伍，value:List<（map:key:源单+目标单+序号,value:(map
           （key：将srcdata中的数据根据”源单目标单映射匹配分录“中的源单字段进行分组，value:分组后的值）)）>)
**/
        }
     }
     static ConvertOperationResult autoPush(QFilter filter){
         //查询指定期间内的，并且清单类型为销售的流向业务清单信息
         DataSet businessListDataSet = QueryServiceHelper.queryDataSet("yrpg_exp_businesslist","yrpg_exp_businesslist",
                 "id", new QFilter[]{filter},null);
         DynamicObjectCollection businessListQuery = ORM.create().toPlainDynamicObjectCollection(businessListDataSet.copy());
         //符合条件的流向业务清单的id
         List<ListSelectedRow> rows = new ArrayList<>();
         businessListQuery.stream().forEach(x -> {
             rows.add(new ListSelectedRow(x.getLong("id")));
         }) ;
         //使用下推规则对流向数据进行下推生成计算单
         PushArgs pushArgs = new PushArgs();
         pushArgs.setSourceEntityNumber("yrpg_exp_businesslist");
         pushArgs.setTargetEntityNumber("yrpg_wages_calate");
         pushArgs.setRuleId(EXP_TO_WAGES_RULE_ID);
         pushArgs.setSelectedRows(rows);
         pushArgs.setAutoSave(true);
         pushArgs.setShowReport(true);
         ConvertOperationResult push = ConvertServiceHelper.push(pushArgs);
         return push;
     }

    /**
     * 根据取数规则设置的计算值，设置进计算奖项中。
     * @param groupSumDs 对应奖项存储的数据集
     * @param compute    计算奖项名称
     * @param yrpgBussinessid   工资计算单源单id集合
     * @param groups  对应奖项需要进行分组的依据
     * @param targetTagName 对应奖项中源单和目标单的映射。
     */
    static void makeCompute(DataSet groupSumDs,String compute,Collection<Object> yrpgBussinessid,String groups
    ,Map<String,String> targetTagName,Map<String,String> objectObjectHashList){
        String[] fieldNames1 = groupSumDs.getRowMeta().getFieldNames();
        List<String> fieldNames1list = new ArrayList<>(Arrays.asList(fieldNames1));
        String tar = String.join(",", fieldNames1list.stream().filter(x->{
            return x.contains("tar");
        }).map(x -> {
            return x.replace("tar_", "");
        }).collect(Collectors.toList()).toArray(new String[]{}));
         String fieldNames = tar+",yrpg_totalamount,yrpg_prize_entry.id,id,yrpg_prize_entry.yrpg_weight_factor,yrpg_prize_entry.yrpg_amount_factor,yrpg_prize_entry.yrpg_entryamount";
        DynamicObjectCollection plainDynamicObjectCollection = ORM.create().toPlainDynamicObjectCollection(groupSumDs.copy().groupBy(groupSumDs.getRowMeta().getFieldNames()).finish()
        );
        //数据包根据分组信息进行分组
        Map<String, List<DynamicObject>> collect = plainDynamicObjectCollection.stream().collect(Collectors.groupingBy(
                x -> {
                    return x.getLong("tar_yrpg_srcid")+",,,"+x.getLong("tar_yrpg_prize_entry.id");
                }, Collectors.toList()
        ));


         Map<String, HashSet<Long>> targetBills = BFTrackerServiceHelper.findTargetBills("yrpg_wages_calate", yrpgBussinessid.toArray(new Long
                []{}));
         if(targetBills.containsKey(compute)){
             Map<String, DynamicObject> collectachivement = new HashMap<>();
            if("yrpg_prize_achivement".equals(compute)){
                DynamicObject[] yrpgProductGear = BusinessDataServiceHelper.load("yrpg_productgear", "id,yrpg_productratio,name", new QFilter[]{new QFilter("status", QFilter.equals, "C")});
                collectachivement = Arrays.stream(yrpgProductGear).collect(Collectors.toMap(x -> {
                    return x.getString("id");
                }, y -> {
                    return y;
                }));
            }
            String id = MetadataDao.getIdByNumber(compute, MetaCategory.Form);
            //获取表单元数据
            FormMetadata formMeta = (FormMetadata) MetadataDao.readRuntimeMeta(id, MetaCategory.Form);
            DataEntityPropertyCollection properties = MetadataServiceHelper.getDataEntityType(compute).getProperties();
            //获取所有控件集合
            List<ControlAp<?>> items = formMeta.getItems();
            Map<String, String> collectProp = new HashMap<>();
            for (ControlAp<?> item : items) {
                //查询奖项明细中的工资计算分录信息
                if("yrpg_prize_entry".equals(item.getKey())){
                    DataEntityPropertyCollection properties1 = ((EntryProp)properties.get(item.getKey())).getItemType().getProperties();
                    collectProp = properties1.stream().filter(x->{
                        return x instanceof BasedataProp;
                    }).collect(Collectors.toMap(x -> {
                        return x.getName();
                    }, y -> {
                        return ((BasedataProp)y).getBaseEntityId();
                    }));
                }
            }
            //查询公式平台计算公式中的字段信息以及公式信息
                DynamicObjectCollection yrpgExpCalculateConfig = QueryServiceHelper.query("yrpg_exp_calculate_config",
                    "yrpg_caculateconfentry.yrpg_targettagname,yrpg_caculateconfentry.yrpg_formulascriptbig", new QFilter[]{
                            new QFilter("yrpg_sourcebill.number", QFilter.equals, compute)
                    });
//            if(yrpgExpCalculateConfig!=null&&!yrpgExpCalculateConfig.isEmpty()) {
//                groups.addAll(yrpgExpCalculateConfig.stream().map(x -> {
//                    return x.getString("yrpg_caculateconfentry.yrpg_targettagname");
//                }).collect(Collectors.toList()));
//            }
            Map<String, String> collect2 = yrpgExpCalculateConfig.stream().collect(Collectors.toMap(x -> {
                return x.getString("yrpg_caculateconfentry.yrpg_targettagname").split("\\.")[
                        x.getString("yrpg_caculateconfentry.yrpg_targettagname").split("\\.").length-1];
            }, y -> {
                return y.getString("yrpg_caculateconfentry.yrpg_formulascriptbig");
            }));
            if(!yrpgExpCalculateConfig.isEmpty()){
                fieldNames  =   fieldNames+","+String.join(",",yrpgExpCalculateConfig.stream().map(x -> {
                    return x.getString("yrpg_caculateconfentry.yrpg_targettagname");
                }).collect(Collectors.toList()).toArray(new String[]{}));
            }
             List<String> collect3 = new ArrayList<>(Arrays.asList(groups.split(","))).stream().distinct().collect(Collectors.toList());
             DynamicObjectCollection idsQuery = QueryServiceHelper.query(compute, String.join(",",collect3.toArray(new String[]{}))+",yrpg_prize_entry.id,id,yrpg_srcid,yrpg_prize_entry.yrpg_weight_factor,yrpg_prize_entry.yrpg_amount_factor,yrpg_prize_entry.yrpg_entryamount,yrpg_totalamount", new QFilter[]{new QFilter("id", QFilter.in, targetBills.containsKey(compute)?targetBills.get(compute):new ArrayList<>())});
             if("yrpg_prize_achivement".equals(compute)){
                 idsQuery = QueryServiceHelper.query(compute, String.join(",",collect3.toArray(new String[]{}))+",yrpg_prize_entry.id,id,yrpg_srcid,yrpg_prize_entry.yrpg_weight_factor,yrpg_prize_entry.yrpg_amount_factor,yrpg_prize_entry.yrpg_entryamount,yrpg_totalamount,yrpg_modelamount", new QFilter[]{new QFilter("id", QFilter.in, targetBills.containsKey(compute)?targetBills.get(compute):new ArrayList<>())});
             }
             Map<String, String> collect1 = idsQuery.stream().collect(Collectors.toMap(x -> {
                return x.getLong("id")+",,,"+x.getLong("yrpg_prize_entry.id");
            }, y -> {
                return y.getLong("yrpg_srcid")+",,,"+y.getLong("yrpg_prize_entry.id");
            }));
            HashMap<String,DynamicObject> values = new HashMap<>();
            DynamicObject[] ids = BusinessDataServiceHelper.load(compute, String.join(",",collect3.toArray(new String[]{}))+",yrpg_prize_entry.id,id,yrpg_srcid,yrpg_prize_entry.yrpg_weight_factor,yrpg_prize_entry.yrpg_amount_factor,yrpg_prize_entry.yrpg_entryamount,yrpg_totalamount", new QFilter[]{new QFilter("id", QFilter.in, targetBills.containsKey(compute)?targetBills.get(compute):new ArrayList<>())});
            if("yrpg_prize_achivement".equals(compute)){
                ids = BusinessDataServiceHelper.load(compute, String.join(",",collect3.toArray(new String[]{}))+",yrpg_prize_entry.id,id,yrpg_srcid,yrpg_prize_entry.yrpg_weight_factor,yrpg_prize_entry.yrpg_amount_factor,yrpg_prize_entry.yrpg_entryamount,yrpg_totalamount,yrpg_modelamount,yrpg_actualentry.yrpg_actualamount,yrpg_actualentry.yrpg_postnumber", new QFilter[]{new QFilter("id", QFilter.in, targetBills.containsKey(compute)?targetBills.get(compute):new ArrayList<>())});
            }
            for(DynamicObject entity : ids){
                //匹配到的奖项数据里面没有分录，则循环数据结果集，并进行计算。
                if(entity.getDynamicObjectCollection("yrpg_prize_entry").isEmpty()){
                    if(collect1.containsKey(entity.getLong("id")+",,,0")){
                        String key = collect1.get(entity.getLong("id") + ",,,0");
                        List<DynamicObject> list = collect.containsKey(key)?collect.get(key):new ArrayList<>();
                         for(DynamicObject resultD : list) {
                             DynamicObject dynamicObject = entity.getDynamicObjectCollection("yrpg_prize_entry").addNew();
                             collect1 = idsQuery.stream().collect(Collectors.toMap(x -> {
                                 return x.getLong("id")+",,,"+x.getLong("yrpg_prize_entry.id");
                             }, y -> {
                                 return y.getLong("yrpg_srcid")+",,,"+y.getLong("yrpg_prize_entry.id");
                             }));
                             for (String tagName : new ArrayList<>(Arrays.asList(groups.split(","))).stream().distinct().collect(Collectors.toList())) {
                                 String tag = tagName;
                                 if (!tagName.contains("null")) {


                                     String[] splitTagName = tagName.replace("tar_", "").split("\\.");

                                     //设置值：1。数据包，通过id查询出数据包，进行赋值，2. 直接赋值非数据包字段。
//                                     dynamicObject.set(tag.split("yrpg_prize_entry.")[1].contains("\\.")?tag.split("yrpg_prize_entry.")[1].split("\\.")[0]:tag.split("yrpg_prize_entry.")[1], (collectProp.containsKey(tag.split("yrpg_prize_entry.")[1].contains("\\.")?collectProp.get(tag.split("yrpg_prize_entry.")[1].split("\\.")[0]):collectProp.get(tag.split("yrpg_prize_entry.")[1])) )? BusinessDataServiceHelper.loadSingle(resultD.containsProperty(tag) ?
//                                             resultD.get(tag) : 0L, collectProp.containsKey(tag.split("yrpg_prize_entry.")[1].contains("\\."))?collectProp.get(tag.split("yrpg_prize_entry.")[1].split("\\.")[0]):"bos_user")  :
//                                             resultD.containsProperty(objectObjectHashList.get()) ?
//                                                     resultD.get(tag) : null);
                                     String name = tag.contains("yrpg_prize_entry.")?(!tag.split("yrpg_prize_entry.")[1].contains("\\.")?tag.split("yrpg_prize_entry.")[1]:tag.split("yrpg_prize_entry.")[1].split("\\.")[0]):tag;
                                     String s = objectObjectHashList.get(tag);
                                     Object value = resultD.containsProperty(s) ?
                                             resultD.get(s) : null;
                                     if(collectProp.containsKey(name)){
                                         if(QueryServiceHelper.exists(collectProp.get(name),new QFilter[]{new QFilter("id",QFilter.equals,value)})){
                                             dynamicObject.set(name, BusinessDataServiceHelper.loadSingle(value,collectProp.get(name)));
                                         }
                                     } else if(dynamicObject.containsProperty(name)){
                                         dynamicObject.set(name, value);
                                     }

                                 }
                             }
                             values.put(compute, entity);
                             collect2.keySet().forEach(x -> {
                                 try {
                                     //批量取公式值对数据包进行计算
                                     dynamicObject.set(x, FormulaEngine.runFormula(collect2.containsKey(x)?collect2.get(x):"", values));
                                 } catch (RunFormulaException e) {
                                     throw new KDBizException(e.getMessage());

                                 }
                             });
                        }
                    }
                }else {
                    //匹配到奖项对应的分录数据，直接进行赋值
                    for (DynamicObject entry : entity.getDynamicObjectCollection("yrpg_prize_entry")) {
                        if (collect1.containsKey((entity.getLong("id")+",,,"+entry.getPkValue().toString()))) {
                            String key = collect1.get((entity.getLong("id")+",,,"+entry.getPkValue().toString()));
                            List<DynamicObject> list = collect.get(key);
                            if (list != null && list.size() >= 1) {
                                for(DynamicObject resultD : list) {
                                    for (String tagName : new ArrayList<>(Arrays.asList(groups.split(","))).stream().distinct().collect(Collectors.toList())) {
                                        String tag = tagName;

                                        String[] splitTagName = tagName.replace("tar_", "").split("\\.");
//                                    entry.set(splitTagName[splitTagName.length-1],collectProp.containsKey(splitTagName[splitTagName.length-1])?BusinessDataServiceHelper.loadSingle(resultD.get(tag),collectProp.get(splitTagName[splitTagName.length-1])):
//                                            resultD.get(tag));
//                                    entry.set(tag.split("yrpg_prize_entry.")[1].contains("\\.")?tag.split("yrpg_prize_entry.")[1].split("\\.")[0]:tag.split("yrpg_prize_entry.")[1], (collectProp.containsKey(tag.split("yrpg_prize_entry.")[1].contains("\\.")?collectProp.get(tag.split("yrpg_prize_entry.")[1].split("\\.")[0]):collectProp.get(tag.split("yrpg_prize_entry.")[1])) )? BusinessDataServiceHelper.loadSingle(resultD.containsProperty(tag) ?
//                                            resultD.get(tag) : 0L, collectProp.containsKey(tag.split("yrpg_prize_entry.")[1].contains("\\."))?collectProp.get(tag.split("yrpg_prize_entry.")[1].split("\\.")[0]):"bos_user")  :
//                                            resultD.containsProperty(tag) ?
//                                                    resultD.get(tag) : null);

                                        String name = tag.contains("yrpg_prize_entry.") ? (!tag.split("yrpg_prize_entry.")[1].contains("\\.") ? tag.split("yrpg_prize_entry.")[1] : tag.split("yrpg_prize_entry.")[1].split("\\.")[0]) : tag;
                                        String s = objectObjectHashList.get(tag);
                                        Object value = resultD.containsProperty(s) ?
                                                resultD.get(s) : null;
                                        if (collectProp.containsKey(name)) {
                                            if (QueryServiceHelper.exists(collectProp.get(name), new QFilter[]{new QFilter("id", QFilter.equals, value)})) {
                                                entry.set(name, BusinessDataServiceHelper.loadSingle(value, collectProp.get(name)));
                                            }
                                        } else if(entry.containsProperty(name)){
                                            entry.set(name, value);
                                        }

                                    }
                                    values.put(compute, entity);
                                    collect2.keySet().forEach(x -> {
                                        try {
                                            //批量取公式值对数据包进行计算
                                            entry.set(x, FormulaEngine.runFormula(collect2.get(x), values));
                                        } catch (RunFormulaException e) {
                                            throw new KDBizException(e.getMessage());
                                        }
                                    });
                                }
                            }
                        }

                    }
                }
                BigDecimal sums = BigDecimal.ZERO;
                //根据权重因子/金额因子计算明细金额
                entity.getDynamicObjectCollection("yrpg_prize_entry").stream().forEach(x->{
                    BigDecimal yrpgWeightFactor = x.getBigDecimal("yrpg_weight_factor").compareTo(BigDecimal.ZERO)==0?BigDecimal.ONE:x.getBigDecimal("yrpg_weight_factor");
                    BigDecimal yrpgAmountFactor = x.getBigDecimal("yrpg_amount_factor");
                    x.set("yrpg_entryamount",yrpgWeightFactor.multiply(yrpgAmountFactor));
                    sums.add(yrpgWeightFactor.multiply(yrpgAmountFactor));
                });
                entity.set("yrpg_totalamount",sums);
                if("yrpg_prize_achivement".equals(compute)){
                    //如果当前计算单等于业绩奖，则根据余额单据信息重新计算应发明细分录数据
                    entity.set("yrpg_modelamount",sums);
                    entity.getDynamicObjectCollection("yrpg_actualentry").clear();
                    BigDecimal actualAmount  = BigDecimal.ZERO;
                    collectachivement.entrySet().forEach(x->{
                        String key = x.getKey();
                        DynamicObject value = x.getValue();
                        DynamicObject entry = entity.getDynamicObjectCollection("yrpg_actualentry").addNew();
                        //设置应发明细实际应发金额
                        entry.set("yrpg_actualamount",sums.multiply(value.getBigDecimal("yrpg_productratio")));
                        //设置应发明细发放档位系数
                        entry.set("yrpg_postnumber",value);
                        actualAmount.add(sums.multiply(value.getBigDecimal("yrpg_productratio")));
                    });
                    //设置表头应发明细总金额
                    entity.set("yrpg_totalamount",actualAmount);
                }
            }

            SaveServiceHelper.save(ids);
        }
    }

    /**
     * 获取本季度开始日期
     * @return
     */
    static String getQuaterStart(){

        LocalDate today = LocalDate.now();
        int month = today.getMonthValue();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        int quarter = ((month - 1) / 3)*3 + 1;
        LocalDate firstDayOfQuarter = LocalDate.of(today.getYear(), quarter, 1);
        return firstDayOfQuarter.format(formatter);
    }

    /**
     * 获取本季度结束日期
     * @return
     */
    static String getQuaterEnd(){
        LocalDate today = LocalDate.now();
        int month = today.getMonthValue();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        int quarter = ((month - 1) / 3)*3 + 1;
        int endMonth = quarter+2;
        LocalDate firstDayOfQuarter1 = LocalDate.of(today.getYear(), quarter, 1);

        LocalDate firstDayOfQuarter = LocalDate.of(today.getYear(), endMonth, firstDayOfQuarter1.lengthOfMonth());
        return firstDayOfQuarter.format(formatter);
    }

    /**
     * 获取当月开始日期
     * @return
     */
    static String getMonthStart(){
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        LocalDate today = LocalDate.now();
        LocalDate firstDayOfQuarter = today.with(TemporalAdjusters.firstDayOfMonth());

        return firstDayOfQuarter.format(formatter);
    }

    /**
     * 获取当月结束日期
     * @return
     */
    static String getMonthEnd(){
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        LocalDate today = LocalDate.now();
        LocalDate firstDayOfQuarter = today.with(TemporalAdjusters.lastDayOfMonth());

        return firstDayOfQuarter.format(formatter);
    }
    //获取本年开始日期
    static String getYearStart(){
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        LocalDate today = LocalDate.now();
        LocalDate firstDayOfQuarter = today.with(TemporalAdjusters.firstDayOfYear());
        return firstDayOfQuarter.format(formatter);
    }
    //获取本年结束日期
    static String getYearEnd(){
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        LocalDate today = LocalDate.now();
        LocalDate firstDayOfQuarter = today.with(TemporalAdjusters.lastDayOfYear());
        return firstDayOfQuarter.format(formatter);
    }
    static String getHalfYearStart(){
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        LocalDate halfYearFirstDay = LocalDate.now();

        LocalDate today = LocalDate.now();
        if (today.getMonthValue() <= 7) {
            // 如果是1月到6月，半年首日为当前年份的1月1日
            halfYearFirstDay = LocalDate.of(today.getYear(), 1, 1);
        } else {
            // 如果是7月到12月，半年首日为当前年份的7月1日
            halfYearFirstDay = LocalDate.of(today.getYear(), 7, 1);
        }
        return halfYearFirstDay.format(formatter);
    }
    //获取本年结束日期
    static String getHalfYearEnd(){
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        LocalDate halfYearFirstDay = LocalDate.now();

        LocalDate today = LocalDate.now();
        if (today.getMonthValue() <= 7) {
            // 如果是1月到6月，半年首日为当前年份的1月1日
            halfYearFirstDay = LocalDate.of(today.getYear(), 6, 1);
        } else {
            // 如果是7月到12月，半年首日为当前年份的7月1日
            halfYearFirstDay = LocalDate.of(today.getYear(), 12, 1);
        }
        return halfYearFirstDay.with(TemporalAdjusters.lastDayOfMonth()).format(formatter);
    }

    /**
     * 根据工资计算明细自动下推奖项信息
     * @param yrpgBussinessid 工资计算明细(按照销售队伍分组)
     * @param yrpgPcAwardTypeGroup 奖项基础资料(按照销售队伍分组)
     * @return 返回每个奖项信息对应的id集合
     */
    public static Map<String,List<Object>> makeComputDetail(Map<String, List<DynamicObject>> yrpgBussinessid,
                                        Map<String, List<DynamicObject>> yrpgPcAwardTypeGroup  ){
        Map<String,List<Object>> result = new HashMap<>();
        //根据工资计算的销售队伍判断要下推的奖项信息
        yrpgBussinessid.entrySet().forEach(x->{
            String key = x.getKey();
            List<DynamicObject> value = x.getValue();
            Map<String, List<DynamicObject>> collect = value.stream().filter(x12->{
                return !StringUtils.isEmpty(x12.getString("yrpg_post.number"));
            }).collect(Collectors.groupingBy(x12 -> {
                return x12.getString("yrpg_post.number");
            }, Collectors.toList()));

            Map<String, List<DynamicObject>> collects = yrpgPcAwardTypeGroup.containsKey(key)?yrpgPcAwardTypeGroup.
                    get(key).stream().filter(x12->{
                        return !StringUtils.isEmpty(x12.getString("yrpg_job.fbasedataid.number"));
                    }).collect(Collectors.groupingBy(x23->{
                return x23.getString("yrpg_job.fbasedataid.number");
            },Collectors.toList())):new HashMap<>();
            collect.keySet().stream().forEach(xvalue->{
                List<Long> computeIds = collect.get(xvalue).stream().map(x1 -> {
                    return x1.getLong("id");
                }).collect(Collectors.toList());
                List<String> yrpgCompute = collects.containsKey(xvalue)?collects.get(xvalue).stream().map(x1 -> {
                    return x1.getString("yrpg_compute");
                }).collect(Collectors.toList()):new ArrayList<>();
                for(String compute : yrpgCompute) {
                    //下推奖项明细成功后，自动获取奖项明细信息
                    OperationResult yrpgWagesCalate = OperationServiceHelper.executeOperate(compute, "yrpg_wages_calate",
                            computeIds.toArray(new Long[]{}), OperateOption.create());
                    if (yrpgWagesCalate.isSuccess()) {
                        result.put(compute,yrpgWagesCalate.getSuccessPkIds());
                    }
                }
            });
            //获取奖项信息


        });
        return result;
    }

    /**
     * 获取取数规则中所有源单的过滤信息
     * @param yrpgFilterText
     * @param billname
     * @return
     */
    public static QFilter getQfilter(String yrpgFilterText,String billname){
        DataRuleResult dataRuleResult = new DataRuleResult();
        //获取entityNumber页面标识中的属性
        MainEntityType dataEntityType = EntityMetadataCache.getDataEntityType(billname);
        String checkPermOrgKey = PermCommonUtil.getCheckPermOrg(dataEntityType);
        if (StringUtils.isEmpty(checkPermOrgKey)) {
            dataRuleResult.setNeedDimCtrl(false);
        }
        DataRuleSingleResult drsr = new DataRuleSingleResult();
        drsr.setFilterJson(yrpgFilterText);
        dataRuleResult.getSingleResultList().add(drsr);
        DynamicObject  bosEntityMetaQuery = QueryServiceHelper.queryOne("bos_entitymeta", "bizapp.number",
                new QFilter[]{new QFilter("number", QCP.equals,billname)});
        QFilter qfilter = PermCommonUtil.convertDataRuleResultToQFilter(dataRuleResult, RequestContext.get().getCurrUserId(),
                bosEntityMetaQuery.getString("bizapp.number")
                ,  billname);
        qfilter = PermCommonUtil.convertQFilter(billname, qfilter);
        return qfilter;
    }
}
